"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "ErrorIndicator", {
    enumerable: true,
    get: function() {
        return ErrorIndicator;
    }
});
const _jsxruntime = require("react/jsx-runtime");
const _Toast = require("../../Toast");
const _CloseIcon = require("../../../icons/CloseIcon");
function ErrorIndicator(param) {
    let { hasStaticIndicator, readyErrors, fullscreen, hide } = param;
    return /*#__PURE__*/ (0, _jsxruntime.jsx)(_Toast.Toast, {
        "data-nextjs-toast": true,
        className: "nextjs-toast-errors-parent" + (hasStaticIndicator ? ' nextjs-error-with-static' : ''),
        onClick: fullscreen,
        children: /*#__PURE__*/ (0, _jsxruntime.jsxs)("div", {
            className: "nextjs-toast-errors",
            children: [
                /*#__PURE__*/ (0, _jsxruntime.jsxs)("svg", {
                    xmlns: "http://www.w3.org/2000/svg",
                    width: "24",
                    height: "24",
                    viewBox: "0 0 24 24",
                    fill: "none",
                    stroke: "currentColor",
                    strokeWidth: "2",
                    strokeLinecap: "round",
                    strokeLinejoin: "round",
                    children: [
                        /*#__PURE__*/ (0, _jsxruntime.jsx)("circle", {
                            cx: "12",
                            cy: "12",
                            r: "10"
                        }),
                        /*#__PURE__*/ (0, _jsxruntime.jsx)("line", {
                            x1: "12",
                            y1: "8",
                            x2: "12",
                            y2: "12"
                        }),
                        /*#__PURE__*/ (0, _jsxruntime.jsx)("line", {
                            x1: "12",
                            y1: "16",
                            x2: "12.01",
                            y2: "16"
                        })
                    ]
                }),
                /*#__PURE__*/ (0, _jsxruntime.jsxs)("span", {
                    children: [
                        readyErrors.length,
                        " issue",
                        readyErrors.length > 1 ? 's' : ''
                    ]
                }),
                /*#__PURE__*/ (0, _jsxruntime.jsx)("button", {
                    "data-nextjs-toast-errors-hide-button": true,
                    className: "nextjs-toast-hide-button",
                    type: "button",
                    onClick: (e)=>{
                        e.stopPropagation();
                        hide();
                    },
                    "aria-label": "Hide Issues",
                    children: /*#__PURE__*/ (0, _jsxruntime.jsx)(_CloseIcon.CloseIcon, {})
                })
            ]
        })
    });
}

if ((typeof exports.default === 'function' || (typeof exports.default === 'object' && exports.default !== null)) && typeof exports.default.__esModule === 'undefined') {
  Object.defineProperty(exports.default, '__esModule', { value: true });
  Object.assign(exports.default, exports);
  module.exports = exports.default;
}

//# sourceMappingURL=ErrorIndicator.js.map