"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
0 && (module.exports = {
    MultipleErrors: null,
    SingleError: null,
    WithStaticIndicator: null,
    default: null
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    MultipleErrors: function() {
        return MultipleErrors;
    },
    SingleError: function() {
        return SingleError;
    },
    WithStaticIndicator: function() {
        return WithStaticIndicator;
    },
    default: function() {
        return _default;
    }
});
const _ErrorIndicator = require("./ErrorIndicator");
const _withshadowportal = require("../../../storybook/with-shadow-portal");
const meta = {
    title: 'ErrorIndicator',
    component: _ErrorIndicator.ErrorIndicator,
    parameters: {
        layout: 'centered'
    },
    decorators: [
        _withshadowportal.withShadowPortal
    ]
};
const _default = meta;
// Mock error for stories
const mockError = {
    id: 1,
    runtime: true,
    error: new Error('Test error'),
    frames: [
        {
            error: true,
            reason: null,
            external: false,
            ignored: false,
            sourceStackFrame: {
                file: 'test.js',
                methodName: '<unknown>',
                arguments: [],
                lineNumber: 1,
                column: 1
            }
        }
    ]
};
const SingleError = {
    args: {
        hasStaticIndicator: false,
        readyErrors: [
            mockError
        ],
        fullscreen: ()=>console.log('Fullscreen clicked'),
        hide: ()=>console.log('Hide clicked')
    }
};
const MultipleErrors = {
    args: {
        hasStaticIndicator: false,
        readyErrors: [
            mockError,
            {
                ...mockError,
                id: 2
            },
            {
                ...mockError,
                id: 3
            }
        ],
        fullscreen: ()=>console.log('Fullscreen clicked'),
        hide: ()=>console.log('Hide clicked')
    }
};
const WithStaticIndicator = {
    args: {
        hasStaticIndicator: true,
        readyErrors: [
            mockError
        ],
        fullscreen: ()=>console.log('Fullscreen clicked'),
        hide: ()=>console.log('Hide clicked')
    }
};

if ((typeof exports.default === 'function' || (typeof exports.default === 'object' && exports.default !== null)) && typeof exports.default.__esModule === 'undefined') {
  Object.defineProperty(exports.default, '__esModule', { value: true });
  Object.assign(exports.default, exports);
  module.exports = exports.default;
}

//# sourceMappingURL=ErrorIndicator.stories.js.map