import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Toast } from '../../Toast';
import { CloseIcon } from '../../../icons/CloseIcon';
export function ErrorIndicator(param) {
    let { hasStaticIndicator, readyErrors, fullscreen, hide } = param;
    return /*#__PURE__*/ _jsx(Toast, {
        "data-nextjs-toast": true,
        className: "nextjs-toast-errors-parent" + (hasStaticIndicator ? ' nextjs-error-with-static' : ''),
        onClick: fullscreen,
        children: /*#__PURE__*/ _jsxs("div", {
            className: "nextjs-toast-errors",
            children: [
                /*#__PURE__*/ _jsxs("svg", {
                    xmlns: "http://www.w3.org/2000/svg",
                    width: "24",
                    height: "24",
                    viewBox: "0 0 24 24",
                    fill: "none",
                    stroke: "currentColor",
                    strokeWidth: "2",
                    strokeLinecap: "round",
                    strokeLinejoin: "round",
                    children: [
                        /*#__PURE__*/ _jsx("circle", {
                            cx: "12",
                            cy: "12",
                            r: "10"
                        }),
                        /*#__PURE__*/ _jsx("line", {
                            x1: "12",
                            y1: "8",
                            x2: "12",
                            y2: "12"
                        }),
                        /*#__PURE__*/ _jsx("line", {
                            x1: "12",
                            y1: "16",
                            x2: "12.01",
                            y2: "16"
                        })
                    ]
                }),
                /*#__PURE__*/ _jsxs("span", {
                    children: [
                        readyErrors.length,
                        " issue",
                        readyErrors.length > 1 ? 's' : ''
                    ]
                }),
                /*#__PURE__*/ _jsx("button", {
                    "data-nextjs-toast-errors-hide-button": true,
                    className: "nextjs-toast-hide-button",
                    type: "button",
                    onClick: (e)=>{
                        e.stopPropagation();
                        hide();
                    },
                    "aria-label": "Hide Issues",
                    children: /*#__PURE__*/ _jsx(CloseIcon, {})
                })
            ]
        })
    });
}

//# sourceMappingURL=ErrorIndicator.js.map