import { ErrorIndicator } from './ErrorIndicator';
import { withShadowPortal } from '../../../storybook/with-shadow-portal';
const meta = {
    title: 'ErrorIndicator',
    component: ErrorIndicator,
    parameters: {
        layout: 'centered'
    },
    decorators: [
        withShadowPortal
    ]
};
export default meta;
// Mock error for stories
const mockError = {
    id: 1,
    runtime: true,
    error: new Error('Test error'),
    frames: [
        {
            error: true,
            reason: null,
            external: false,
            ignored: false,
            sourceStackFrame: {
                file: 'test.js',
                methodName: '<unknown>',
                arguments: [],
                lineNumber: 1,
                column: 1
            }
        }
    ]
};
export const SingleError = {
    args: {
        hasStaticIndicator: false,
        readyErrors: [
            mockError
        ],
        fullscreen: ()=>console.log('Fullscreen clicked'),
        hide: ()=>console.log('Hide clicked')
    }
};
export const MultipleErrors = {
    args: {
        hasStaticIndicator: false,
        readyErrors: [
            mockError,
            {
                ...mockError,
                id: 2
            },
            {
                ...mockError,
                id: 3
            }
        ],
        fullscreen: ()=>console.log('Fullscreen clicked'),
        hide: ()=>console.log('Hide clicked')
    }
};
export const WithStaticIndicator = {
    args: {
        hasStaticIndicator: true,
        readyErrors: [
            mockError
        ],
        fullscreen: ()=>console.log('Fullscreen clicked'),
        hide: ()=>console.log('Hide clicked')
    }
};

//# sourceMappingURL=ErrorIndicator.stories.js.map