import { jsx as _jsx } from "react/jsx-runtime";
import { useCallback } from 'react';
import { HotlinkedText } from '../components/hot-linked-text';
import { ErrorOverlayLayout } from '../components/Errors/ErrorOverlayLayout/ErrorOverlayLayout';
export function RootLayoutMissingTagsError(param) {
    let { missingTags, versionInfo } = param;
    const noop = useCallback(()=>{}, []);
    return /*#__PURE__*/ _jsx(ErrorOverlayLayout, {
        errorType: "Missing Required HTML Tag",
        errorMessage: /*#__PURE__*/ _jsx(HotlinkedText, {
            text: "The following tags are missing in the Root Layout: " + missingTags.map((tagName)=>"<" + tagName + ">").join(', ') + ".\nRead more at https://nextjs.org/docs/messages/missing-root-layout-tags"
        }),
        onClose: noop,
        versionInfo: versionInfo
    });
}

//# sourceMappingURL=RootLayoutMissingTagsError.js.map